diff --git a/sys/dev/raid/arcmsr/arcmsr.c b/sys/dev/raid/arcmsr/arcmsr.c
index f08380d..f0467c8 100644
--- a/sys/dev/raid/arcmsr/arcmsr.c
+++ b/sys/dev/raid/arcmsr/arcmsr.c
@@ -3608,7 +4231,7 @@ static int arcmsr_attach(device_t dev)
 			pci_release_msi(dev);
 		xpt_bus_deregister(cam_sim_path(acb->psim));
 		cam_sim_free(acb->psim);
-		ARCMSR_LOCK_DESTROY(&acb->qbuffer_lock);
+		arcmsr_mutex_destroy(acb);
 		kprintf("arcmsr%d: xpt_create_path failure!\n", unit);
 		return ENXIO;
 	}
@@ -3616,16 +4239,16 @@ static int arcmsr_attach(device_t dev)
 	****************************************************
 	*/
 	xpt_setup_ccb(&csa.ccb_h, acb->ppath, /*priority*/5);
-	csa.ccb_h.func_code=XPT_SASYNC_CB;
-	csa.event_enable=AC_FOUND_DEVICE|AC_LOST_DEVICE;
-	csa.callback=arcmsr_async;
-	csa.callback_arg=acb->psim;
+	csa.ccb_h.func_code = XPT_SASYNC_CB;
+	csa.event_enable = AC_FOUND_DEVICE|AC_LOST_DEVICE;
+	csa.callback = arcmsr_async;
+	csa.callback_arg = acb->psim;
 	xpt_action((union ccb *)&csa);
-	ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
+	ARCMSR_LOCK_RELEASE(&acb->isr_lock);
 	/* Create the control device.  */
-	acb->ioctl_dev=make_dev(&arcmsr_ops, unit, UID_ROOT, GID_WHEEL /* GID_OPERATOR */, S_IRUSR | S_IWUSR, "arcmsr%d", unit);
+	acb->ioctl_dev = make_dev(&arcmsr_ops, unit, UID_ROOT, GID_WHEEL /* GID_OPERATOR */, S_IRUSR | S_IWUSR, "arcmsr%d", unit);
 
-	acb->ioctl_dev->si_drv1=acb;
+	acb->ioctl_dev->si_drv1 = acb;
 	(void)make_dev_alias(acb->ioctl_dev, "arc%d", unit);
 	arcmsr_callout_init(&acb->devmap_callout);
 	callout_reset(&acb->devmap_callout, 60 * hz, arcmsr_polling_devmap, acb);
@@ -3639,15 +4262,17 @@ static int arcmsr_attach(device_t dev)
 static int arcmsr_probe(device_t dev)
 {
 	u_int32_t id;
+	u_int16_t sub_device_id;
 	static char buf[256];
-	char x_type[]={"X-TYPE"};
+	char x_type[]={"unknown"};
 	char *type;
 	int raid6 = 1;
 
 	if (pci_get_vendor(dev) != PCI_VENDOR_ID_ARECA) {
 		return (ENXIO);
 	}
-	switch(id=pci_get_devid(dev)) {
+	sub_device_id = pci_read_config(dev, PCIR_SUBDEV_0, 2);
+	switch(id = pci_get_devid(dev)) {
 	case PCIDevVenIDARC1110:
 	case PCIDevVenIDARC1200:
 	case PCIDevVenIDARC1201:
@@ -3665,7 +4290,7 @@ static int arcmsr_probe(device_t dev)
 	case PCIDevVenIDARC1261:
 	case PCIDevVenIDARC1270:
 	case PCIDevVenIDARC1280:
-		type = "SATA";
+		type = "SATA 3G";
 		break;
 	case PCIDevVenIDARC1212:
 	case PCIDevVenIDARC1222:
@@ -3679,16 +4304,24 @@ static int arcmsr_probe(device_t dev)
 	case PCIDevVenIDARC1882:
 	case PCIDevVenIDARC1213:
 	case PCIDevVenIDARC1223:
-		type = "SAS 6G";
+		if (sub_device_id == ARECA_SUB_DEV_ID_1883)
+			type = "SAS 12G";
+		else
+			type = "SAS 6G";
 		arcmsr_msi_enable = 0;
 		break;
+	case PCIDevVenIDARC1214:
+		type = "SATA 6G";
+		break;
 	default:
 		type = x_type;
+		raid6 = 0;
 		break;
 	}
 	if(type == x_type)
 		return(ENXIO);
-	ksprintf(buf, "Areca %s Host Adapter RAID Controller%s", type, raid6 ? " (RAID6 capable)" : "");
+	ksprintf(buf, "Areca %s Host Adapter RAID Controller %s\n%s\n",
+		type, raid6 ? "(RAID6 capable)" : "", ARCMSR_DRIVER_VERSION);
 	device_set_desc_copy(dev, buf);
 	return (BUS_PROBE_DEFAULT);
 }
@@ -3703,7 +4336,7 @@ static int arcmsr_shutdown(device_t dev)
 	struct AdapterControlBlock *acb=(struct AdapterControlBlock *)device_get_softc(dev);
 
 	/* stop adapter background rebuild */
-	ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
+	ARCMSR_LOCK_ACQUIRE(&acb->isr_lock);
 	/* disable all outbound interrupt */
 	arcmsr_disable_allintr(acb);
 	arcmsr_stop_adapter_bgrb(acb);
@@ -3711,28 +4344,26 @@ static int arcmsr_shutdown(device_t dev)
 	/* abort all outstanding command */
 	acb->acb_flags |= ACB_F_SCSISTOPADAPTER;
 	acb->acb_flags &= ~ACB_F_IOP_INITED;
-	if(acb->srboutstandingcount!=0) {
+	if(acb->srboutstandingcount != 0) {
 		/*clear and abort all outbound posted Q*/
 		arcmsr_done4abort_postqueue(acb);
 		/* talk to iop 331 outstanding command aborted*/
 		arcmsr_abort_allcmd(acb);
-		for(i=0;i<ARCMSR_MAX_FREESRB_NUM;i++) {
-			srb=acb->psrb_pool[i];
-			if(srb->srb_state==ARCMSR_SRB_START) {
-				srb->srb_state=ARCMSR_SRB_ABORTED;
+		for(i=0; i < ARCMSR_MAX_FREESRB_NUM; i++) {
+			srb = acb->psrb_pool[i];
+			if(srb->srb_state == ARCMSR_SRB_START) {
+				srb->srb_state = ARCMSR_SRB_ABORTED;
 				srb->pccb->ccb_h.status |= CAM_REQ_ABORTED;
 				arcmsr_srb_complete(srb, 1);
 			}
 		}
 	}
-	acb->srboutstandingcount=0;
-	acb->workingsrb_doneindex=0;
-	acb->workingsrb_startindex=0;
-#ifdef ARCMSR_DEBUG1
+	acb->srboutstandingcount = 0;
+	acb->workingsrb_doneindex = 0;
+	acb->workingsrb_startindex = 0;
 	acb->pktRequestCount = 0;
 	acb->pktReturnCount = 0;
-#endif
-	ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
+	ARCMSR_LOCK_RELEASE(&acb->isr_lock);
 	return (0);
 }
 /*
@@ -3754,13 +4385,13 @@ static int arcmsr_detach(device_t dev)
 	bus_release_resource(dev, SYS_RES_IRQ, 0, acb->irqres);
 	if (acb->irq_type == PCI_INTR_TYPE_MSI)
 		pci_release_msi(dev);
-	ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
+	ARCMSR_LOCK_ACQUIRE(&acb->isr_lock);
 	xpt_async(AC_LOST_DEVICE, acb->ppath, NULL);
 	xpt_free_path(acb->ppath);
 	xpt_bus_deregister(cam_sim_path(acb->psim));
 	cam_sim_free(acb->psim);
-	ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
-	ARCMSR_LOCK_DESTROY(&acb->qbuffer_lock);
+	ARCMSR_LOCK_RELEASE(&acb->isr_lock);
+	arcmsr_mutex_destroy(acb);
 	return (0);
 }
 
@@ -3769,9 +4400,9 @@ static void arcmsr_dump_data(struct AdapterControlBlock *acb)
 {
 	if((acb->pktRequestCount - acb->pktReturnCount) == 0)
 		return;
-	printf("Command Request Count   =0x%x\n",acb->pktRequestCount);
-	printf("Command Return Count    =0x%x\n",acb->pktReturnCount);
-	printf("Command (Req-Rtn) Count =0x%x\n",(acb->pktRequestCount - acb->pktReturnCount));
-	printf("Queued Command Count    =0x%x\n",acb->srboutstandingcount);
+	kprintf("Command Request Count   =0x%x\n",acb->pktRequestCount);
+	kprintf("Command Return Count    =0x%x\n",acb->pktReturnCount);
+	kprintf("Command (Req-Rtn) Count =0x%x\n",(acb->pktRequestCount - acb->pktReturnCount));
+	kprintf("Queued Command Count    =0x%x\n",acb->srboutstandingcount);
 }
 #endif
diff --git a/sys/dev/raid/arcmsr/arcmsr.h b/sys/dev/raid/arcmsr/arcmsr.h
index ed91264..45edfff 100644
--- a/sys/dev/raid/arcmsr/arcmsr.h
+++ b/sys/dev/raid/arcmsr/arcmsr.h
@@ -1,17 +1,14 @@
 /*
-***********************************************************************************************
-**        O.S   : FreeBSD
+********************************************************************************
+**        OS    : FreeBSD
 **   FILE NAME  : arcmsr.h
 **        BY    : Erich Chen, Ching Huang
-**   Description: SCSI RAID Device Driver for
-**                ARECA SATA/SAS RAID HOST Adapter
-**                [RAID controller:INTEL 331(PCI-X) 341(PCI-EXPRESS) chip set]
-***********************************************************************************************
-************************************************************************
-** Copyright (C) 2002 - 2010, Areca Technology Corporation All rights reserved.
-**
-**     Web site: www.areca.com.tw
-**       E-mail: erich@areca.com.tw; ching2048@areca.com.tw
+**   Description: SCSI RAID Device Driver for 
+**                ARECA (ARC11XX/ARC12XX/ARC13XX/ARC16XX/ARC188x)
+**                SATA/SAS RAID HOST Adapter
+********************************************************************************
+********************************************************************************
+** Copyright (C) 2002 - 2012, Areca Technology Corporation All rights reserved.
 **
 ** Redistribution and use in source and binary forms,with or without
 ** modification,are permitted provided that the following conditions
@@ -35,27 +32,28 @@
 **(INCLUDING NEGLIGENCE OR OTHERWISE)ARISING IN ANY WAY OUT OF THE USE OF
 ** THIS SOFTWARE,EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **************************************************************************
-* $FreeBSD: src/sys/dev/arcmsr/arcmsr.h,v 1.10 2012/09/04 05:15:54 delphij Exp $
+* $FreeBSD: head/sys/dev/arcmsr/arcmsr.h 259565 2013-12-18 19:25:40Z delphij $
 */
 
 #include <sys/ioccom.h>
 
-#define ARCMSR_SCSI_INITIATOR_ID                                              255
-#define ARCMSR_DEV_SECTOR_SIZE                                                512
-#define ARCMSR_MAX_XFER_SECTORS                                              4096
-#define ARCMSR_MAX_TARGETID                                                    17 /*16 max target id + 1*/
-#define ARCMSR_MAX_TARGETLUN                                                    8 /*8*/
-#define ARCMSR_MAX_CHIPTYPE_NUM                                                 4
-#define ARCMSR_MAX_OUTSTANDING_CMD                                            256
-#define ARCMSR_MAX_START_JOB                                                  257
-#define ARCMSR_MAX_CMD_PERLUN                          ARCMSR_MAX_OUTSTANDING_CMD
-#define ARCMSR_MAX_FREESRB_NUM				384
-#define ARCMSR_MAX_QBUFFER                                                   4096 /* ioctl QBUFFER */
-#define ARCMSR_MAX_SG_ENTRIES                                                  38 /* max 38*/
-#define ARCMSR_MAX_ADAPTER                                                      4
-#define ARCMSR_RELEASE_SIMQ_LEVEL                                             230
-#define ARCMSR_MAX_HBB_POSTQUEUE                                              264 /* (ARCMSR_MAX_OUTSTANDING_CMD+8) */
-#define	ARCMSR_TIMEOUT_DELAY				60 /* in sec */
+#define ARCMSR_SCSI_INITIATOR_ID	255
+#define ARCMSR_DEV_SECTOR_SIZE		512
+#define ARCMSR_MAX_XFER_SECTORS		4096
+#define ARCMSR_MAX_TARGETID		17	/*16 max target id + 1*/
+#define ARCMSR_MAX_TARGETLUN		8	/*8*/
+#define ARCMSR_MAX_CHIPTYPE_NUM		4
+#define ARCMSR_MAX_OUTSTANDING_CMD	256
+#define ARCMSR_MAX_START_JOB		256
+#define ARCMSR_MAX_CMD_PERLUN		ARCMSR_MAX_OUTSTANDING_CMD
+#define ARCMSR_MAX_FREESRB_NUM		384
+#define ARCMSR_MAX_QBUFFER		4096	/* ioctl QBUFFER */
+#define ARCMSR_MAX_SG_ENTRIES		38	/* max 38*/
+#define ARCMSR_MAX_ADAPTER		4
+#define ARCMSR_RELEASE_SIMQ_LEVEL	230
+#define ARCMSR_MAX_HBB_POSTQUEUE	264	/* (ARCMSR_MAX_OUTSTANDING_CMD+8) */
+#define ARCMSR_MAX_HBD_POSTQUEUE	256
+#define	ARCMSR_TIMEOUT_DELAY		60	/* in sec */
 /*
 *********************************************************************
 */
@@ -72,37 +70,48 @@
 #ifndef offsetof
 	#define offsetof(type, member)  ((size_t)(&((type *)0)->member))
 #endif
+
+#define ARCMSR_LOCK_INIT(l, s)	lockinit(l, s, 0, LK_CANRECURSE)
+#define ARCMSR_LOCK_DESTROY(l)	lockuninit(l)
+#define ARCMSR_LOCK_ACQUIRE(l)	lockmgr(l, LK_EXCLUSIVE)
+#define ARCMSR_LOCK_RELEASE(l)	lockmgr(l, LK_RELEASE)
+#define ARCMSR_LOCK_TRY(l)	lockmgr(&l, LK_EXCLUSIVE|LK_NOWAIT)
+#define arcmsr_htole32(x)	htole32(x)
+typedef struct lock		arcmsr_lock_t;
+
 /*
 **********************************************************************************
 **
 **********************************************************************************
 */
-#define PCI_VENDOR_ID_ARECA                                                0x17D3 /* Vendor ID	*/
-#define PCI_DEVICE_ID_ARECA_1110                                           0x1110 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1120                                           0x1120 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1130                                           0x1130 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1160                                           0x1160 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1170                                           0x1170 /* Device ID	*/
+#define PCI_VENDOR_ID_ARECA		0x17D3 /* Vendor ID	*/
+#define PCI_DEVICE_ID_ARECA_1110        0x1110 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1120        0x1120 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1130        0x1130 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1160        0x1160 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1170        0x1170 /* Device ID	*/
 #define PCI_DEVICE_ID_ARECA_1200        0x1200 /* Device ID	*/
 #define PCI_DEVICE_ID_ARECA_1201        0x1201 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1210                                           0x1210 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1210        0x1210 /* Device ID	*/
 #define PCI_DEVICE_ID_ARECA_1212        0x1212 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1220                                           0x1220 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1214        0x1214 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1220        0x1220 /* Device ID	*/
 #define PCI_DEVICE_ID_ARECA_1222        0x1222 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1230                                           0x1230 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1230        0x1230 /* Device ID	*/
 #define PCI_DEVICE_ID_ARECA_1231        0x1231 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1260                                           0x1260 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1260        0x1260 /* Device ID	*/
 #define PCI_DEVICE_ID_ARECA_1261        0x1261 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1270                                           0x1270 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1280                                           0x1280 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1380                                           0x1380 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1381                                           0x1381 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1680                                           0x1680 /* Device ID	*/
-#define PCI_DEVICE_ID_ARECA_1681                                           0x1681 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1270        0x1270 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1280        0x1280 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1380        0x1380 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1381        0x1381 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1680        0x1680 /* Device ID	*/
+#define PCI_DEVICE_ID_ARECA_1681        0x1681 /* Device ID	*/
 #define PCI_DEVICE_ID_ARECA_1880        0x1880 /* Device ID	*/
 
 #define ARECA_SUB_DEV_ID_1880	0x1880 /* Subsystem Device ID	*/
 #define ARECA_SUB_DEV_ID_1882	0x1882 /* Subsystem Device ID	*/
+#define ARECA_SUB_DEV_ID_1883	0x1883 /* Subsystem Device ID	*/
 #define ARECA_SUB_DEV_ID_1212	0x1212 /* Subsystem Device ID	*/
 #define ARECA_SUB_DEV_ID_1213	0x1213 /* Subsystem Device ID	*/
 #define ARECA_SUB_DEV_ID_1222	0x1222 /* Subsystem Device ID	*/
@@ -118,6 +127,7 @@
 #define PCIDevVenIDARC1210              0x121017D3 /* Vendor Device ID	*/
 #define PCIDevVenIDARC1212              0x121217D3 /* Vendor Device ID	*/
 #define PCIDevVenIDARC1213              0x121317D3 /* Vendor Device ID	*/
+#define PCIDevVenIDARC1214              0x121417D3 /* Vendor Device ID	*/
 #define PCIDevVenIDARC1220              0x122017D3 /* Vendor Device ID	*/
 #define PCIDevVenIDARC1222              0x122217D3 /* Vendor Device ID	*/
 #define PCIDevVenIDARC1223              0x122317D3 /* Vendor Device ID	*/
@@ -139,35 +149,41 @@
 	#define	PCIR_BAR(x)	(PCIR_BARS + (x) * 4)
 #endif
 
-#define PCI_BASE_ADDR0                                               0x10
-#define PCI_BASE_ADDR1                                               0x14
-#define PCI_BASE_ADDR2                                               0x18
-#define PCI_BASE_ADDR3                                               0x1C
-#define PCI_BASE_ADDR4                                               0x20
-#define PCI_BASE_ADDR5                                               0x24
+#define PCI_BASE_ADDR0                  0x10
+#define PCI_BASE_ADDR1                  0x14
+#define PCI_BASE_ADDR2                  0x18
+#define PCI_BASE_ADDR3                  0x1C
+#define PCI_BASE_ADDR4                  0x20
+#define PCI_BASE_ADDR5                  0x24
 /*
 **********************************************************************************
 **
 **********************************************************************************
 */
-#define ARCMSR_SCSICMD_IOCTL                                         0x77
-#define ARCMSR_CDEVSW_IOCTL                                          0x88
-#define ARCMSR_MESSAGE_FAIL                                          0x0001
-#define	ARCMSR_MESSAGE_SUCCESS                                       0x0000
+#define ARCMSR_SCSICMD_IOCTL            0x77
+#define ARCMSR_CDEVSW_IOCTL             0x88
+#define ARCMSR_MESSAGE_FAIL             0x0001
+#define	ARCMSR_MESSAGE_SUCCESS          0x0000
 /*
 **********************************************************************************
 **
 **********************************************************************************
 */
-#define arcmsr_ccbsrb_ptr                  							spriv_ptr0
-#define arcmsr_ccbacb_ptr                  							spriv_ptr1
-#define dma_addr_hi32(addr)                							(u_int32_t) ((addr>>16)>>16)
-#define dma_addr_lo32(addr)                							(u_int32_t) (addr & 0xffffffff)
-#define get_min(x,y)            ((x) < (y) ? (x) : (y))
-#define get_max(x,y)            ((x) < (y) ? (y) : (x))
+#define arcmsr_ccbsrb_ptr	spriv_ptr0
+#define arcmsr_ccbacb_ptr	spriv_ptr1
+#define dma_addr_hi32(addr)	(u_int32_t) ((addr>>16)>>16)
+#define dma_addr_lo32(addr)	(u_int32_t) (addr & 0xffffffff)
+#define get_min(x,y)		((x) < (y) ? (x) : (y))
+#define get_max(x,y)		((x) < (y) ? (y) : (x))
+/*
+**************************************************************************
+**************************************************************************
+*/
+#define CHIP_REG_READ32(s, b, r)	bus_space_read_4(acb->btag[b], acb->bhandle[b], offsetof(struct s, r))
+#define CHIP_REG_WRITE32(s, b, r, d)	bus_space_write_4(acb->btag[b], acb->bhandle[b], offsetof(struct s, r), d)
 /*
 **********************************************************************************
-**
+**    IOCTL CONTROL Mail Box
 **********************************************************************************
 */
 struct CMD_MESSAGE {
@@ -187,17 +203,17 @@ struct CMD_MESSAGE_FIELD {
 /************************************************************************/
 /************************************************************************/
 
-#define ARCMSR_IOP_ERROR_ILLEGALPCI            	0x0001
-#define ARCMSR_IOP_ERROR_VENDORID              	0x0002
-#define ARCMSR_IOP_ERROR_DEVICEID              	0x0002
-#define ARCMSR_IOP_ERROR_ILLEGALCDB           	0x0003
-#define ARCMSR_IOP_ERROR_UNKNOW_CDBERR        	0x0004
-#define ARCMSR_SYS_ERROR_MEMORY_ALLOCATE    	0x0005
-#define ARCMSR_SYS_ERROR_MEMORY_CROSS4G     	0x0006
-#define ARCMSR_SYS_ERROR_MEMORY_LACK        	0x0007
-#define ARCMSR_SYS_ERROR_MEMORY_RANGE           0x0008
-#define ARCMSR_SYS_ERROR_DEVICE_BASE            0x0009
-#define ARCMSR_SYS_ERROR_PORT_VALIDATE          0x000A
+#define ARCMSR_IOP_ERROR_ILLEGALPCI		0x0001
+#define ARCMSR_IOP_ERROR_VENDORID		0x0002
+#define ARCMSR_IOP_ERROR_DEVICEID		0x0002
+#define ARCMSR_IOP_ERROR_ILLEGALCDB		0x0003
+#define ARCMSR_IOP_ERROR_UNKNOW_CDBERR		0x0004
+#define ARCMSR_SYS_ERROR_MEMORY_ALLOCATE	0x0005
+#define ARCMSR_SYS_ERROR_MEMORY_CROSS4G		0x0006
+#define ARCMSR_SYS_ERROR_MEMORY_LACK		0x0007
+#define ARCMSR_SYS_ERROR_MEMORY_RANGE		0x0008
+#define ARCMSR_SYS_ERROR_DEVICE_BASE		0x0009
+#define ARCMSR_SYS_ERROR_PORT_VALIDATE		0x000A
 
 /*DeviceType*/
 #define ARECA_SATA_RAID                      	0x90000000
@@ -214,7 +230,7 @@ struct CMD_MESSAGE_FIELD {
 #define FUNCTION_FLUSH_ADAPTER_CACHE           	0x0809
 /*
 ************************************************************************
-**        IOCTL CONTROL CODE
+**      IOCTL CONTROL CODE
 ************************************************************************
 */
 /* ARECA IO CONTROL CODE*/
@@ -224,16 +240,50 @@ struct CMD_MESSAGE_FIELD {
 #define ARCMSR_MESSAGE_CLEAR_WQBUFFER          	_IOWR('F', FUNCTION_CLEAR_WQBUFFER, struct CMD_MESSAGE_FIELD)
 #define ARCMSR_MESSAGE_CLEAR_ALLQBUFFER        	_IOWR('F', FUNCTION_CLEAR_ALLQBUFFER, struct CMD_MESSAGE_FIELD)
 #define ARCMSR_MESSAGE_REQUEST_RETURNCODE_3F   	_IOWR('F', FUNCTION_REQUEST_RETURNCODE_3F, struct CMD_MESSAGE_FIELD)
-#define ARCMSR_MESSAGE_SAY_HELLO               	_IOWR('F', FUNCTION_SAY_HELLO, struct CMD_MESSAGE_FIELD)
+#define ARCMSR_MESSAGE_SAY_HELLO               	_IOWR('F', FUNCTION_SAY_HELLO, struct CMD_MESSAGE_FIELD) 
 #define ARCMSR_MESSAGE_SAY_GOODBYE              _IOWR('F', FUNCTION_SAY_GOODBYE, struct CMD_MESSAGE_FIELD)
 #define ARCMSR_MESSAGE_FLUSH_ADAPTER_CACHE      _IOWR('F', FUNCTION_FLUSH_ADAPTER_CACHE, struct CMD_MESSAGE_FIELD)
 
 /* ARECA IOCTL ReturnCode */
-#define ARCMSR_MESSAGE_RETURNCODE_OK              0x00000001
-#define ARCMSR_MESSAGE_RETURNCODE_ERROR           0x00000006
-#define ARCMSR_MESSAGE_RETURNCODE_3F              0x0000003F
-#define ARCMSR_IOCTL_RETURNCODE_BUS_HANG_ON		0x00000088
-/*
+#define ARCMSR_MESSAGE_RETURNCODE_OK		0x00000001
+#define ARCMSR_MESSAGE_RETURNCODE_ERROR		0x00000006
+#define ARCMSR_MESSAGE_RETURNCODE_3F		0x0000003F
+#define ARCMSR_IOCTL_RETURNCODE_BUS_HANG_ON	0x00000088
+/* 
+************************************************************************
+**                SPEC. for Areca HBA adapter
+************************************************************************
+*/
+/* signature of set and get firmware config */
+#define ARCMSR_SIGNATURE_GET_CONFIG		0x87974060
+#define ARCMSR_SIGNATURE_SET_CONFIG		0x87974063
+/* message code of inbound message register */
+#define ARCMSR_INBOUND_MESG0_NOP		0x00000000
+#define ARCMSR_INBOUND_MESG0_GET_CONFIG		0x00000001
+#define ARCMSR_INBOUND_MESG0_SET_CONFIG		0x00000002
+#define ARCMSR_INBOUND_MESG0_ABORT_CMD		0x00000003
+#define ARCMSR_INBOUND_MESG0_STOP_BGRB		0x00000004
+#define ARCMSR_INBOUND_MESG0_FLUSH_CACHE	0x00000005
+#define ARCMSR_INBOUND_MESG0_START_BGRB		0x00000006
+#define ARCMSR_INBOUND_MESG0_CHK331PENDING	0x00000007
+#define ARCMSR_INBOUND_MESG0_SYNC_TIMER		0x00000008
+/* doorbell interrupt generator */
+#define ARCMSR_INBOUND_DRIVER_DATA_WRITE_OK	0x00000001
+#define ARCMSR_INBOUND_DRIVER_DATA_READ_OK	0x00000002
+#define ARCMSR_OUTBOUND_IOP331_DATA_WRITE_OK	0x00000001
+#define ARCMSR_OUTBOUND_IOP331_DATA_READ_OK	0x00000002
+/* srb areca cdb flag */
+#define ARCMSR_SRBPOST_FLAG_SGL_BSIZE		0x80000000
+#define ARCMSR_SRBPOST_FLAG_IAM_BIOS		0x40000000
+#define ARCMSR_SRBREPLY_FLAG_IAM_BIOS		0x40000000
+#define ARCMSR_SRBREPLY_FLAG_ERROR		0x10000000
+#define ARCMSR_SRBREPLY_FLAG_ERROR_MODE0        0x10000000
+#define ARCMSR_SRBREPLY_FLAG_ERROR_MODE1	0x00000001
+/* outbound firmware ok */
+#define ARCMSR_OUTBOUND_MESG1_FIRMWARE_OK	0x80000000
+
+#define ARCMSR_ARC1680_BUS_RESET		0x00000003
+/* 
 ************************************************************************
 **                SPEC. for Areca HBB adapter
 ************************************************************************
@@ -250,20 +300,20 @@ struct CMD_MESSAGE_FIELD {
 #define ARCMSR_IOP2DRV_CDB_DONE                 0x00000004
 #define ARCMSR_IOP2DRV_MESSAGE_CMD_DONE         0x00000008
 
-#define ARCMSR_DOORBELL_HANDLE_INT		        0x0000000F
+#define ARCMSR_DOORBELL_HANDLE_INT		0x0000000F
 #define ARCMSR_DOORBELL_INT_CLEAR_PATTERN       0xFF00FFF0
 #define ARCMSR_MESSAGE_INT_CLEAR_PATTERN        0xFF00FFF7
 
-#define ARCMSR_MESSAGE_GET_CONFIG				0x00010008	/* (ARCMSR_INBOUND_MESG0_GET_CONFIG<<16)|ARCMSR_DRV2IOP_MESSAGE_CMD_POSTED) */
-#define ARCMSR_MESSAGE_SET_CONFIG				0x00020008	/* (ARCMSR_INBOUND_MESG0_SET_CONFIG<<16)|ARCMSR_DRV2IOP_MESSAGE_CMD_POSTED) */
-#define ARCMSR_MESSAGE_ABORT_CMD				0x00030008	/* (ARCMSR_INBOUND_MESG0_ABORT_CMD<<16)|ARCMSR_DRV2IOP_MESSAGE_CMD_POSTED) */
-#define ARCMSR_MESSAGE_STOP_BGRB				0x00040008	/* (ARCMSR_INBOUND_MESG0_STOP_BGRB<<16)|ARCMSR_DRV2IOP_MESSAGE_CMD_POSTED) */
+#define ARCMSR_MESSAGE_GET_CONFIG		0x00010008	/* (ARCMSR_INBOUND_MESG0_GET_CONFIG<<16)|ARCMSR_DRV2IOP_MESSAGE_CMD_POSTED) */
+#define ARCMSR_MESSAGE_SET_CONFIG		0x00020008	/* (ARCMSR_INBOUND_MESG0_SET_CONFIG<<16)|ARCMSR_DRV2IOP_MESSAGE_CMD_POSTED) */
+#define ARCMSR_MESSAGE_ABORT_CMD		0x00030008	/* (ARCMSR_INBOUND_MESG0_ABORT_CMD<<16)|ARCMSR_DRV2IOP_MESSAGE_CMD_POSTED) */
+#define ARCMSR_MESSAGE_STOP_BGRB		0x00040008	/* (ARCMSR_INBOUND_MESG0_STOP_BGRB<<16)|ARCMSR_DRV2IOP_MESSAGE_CMD_POSTED) */
 #define ARCMSR_MESSAGE_FLUSH_CACHE              0x00050008	/* (ARCMSR_INBOUND_MESG0_FLUSH_CACHE<<16)|ARCMSR_DRV2IOP_MESSAGE_CMD_POSTED) */
-#define ARCMSR_MESSAGE_START_BGRB				0x00060008	/* (ARCMSR_INBOUND_MESG0_START_BGRB<<16)|ARCMSR_DRV2IOP_MESSAGE_CMD_POSTED) */
-#define ARCMSR_MESSAGE_START_DRIVER_MODE		0x000E0008
-#define ARCMSR_MESSAGE_SET_POST_WINDOW		    0x000F0008
-#define ARCMSR_MESSAGE_ACTIVE_EOI_MODE		    0x00100008
-#define ARCMSR_MESSAGE_FIRMWARE_OK				0x80000000	/* ARCMSR_OUTBOUND_MESG1_FIRMWARE_OK */
+#define ARCMSR_MESSAGE_START_BGRB		0x00060008	/* (ARCMSR_INBOUND_MESG0_START_BGRB<<16)|ARCMSR_DRV2IOP_MESSAGE_CMD_POSTED) */
+#define ARCMSR_MESSAGE_START_DRIVER_MODE	0x000E0008	
+#define ARCMSR_MESSAGE_SET_POST_WINDOW		0x000F0008	
+#define ARCMSR_MESSAGE_ACTIVE_EOI_MODE		0x00100008
+#define ARCMSR_MESSAGE_FIRMWARE_OK		0x80000000	/* ARCMSR_OUTBOUND_MESG1_FIRMWARE_OK */
 
 #define ARCMSR_DRV2IOP_DATA_WRITE_OK            0x00000001	/* ioctl transfer */
 #define ARCMSR_DRV2IOP_DATA_READ_OK             0x00000002	/* ioctl transfer */
@@ -272,14 +322,14 @@ struct CMD_MESSAGE_FIELD {
 #define ARCMSR_DRV2IOP_END_OF_INTERRUPT         0x00000010  /*  */
 
 /* data tunnel buffer between user space program and its firmware */
-#define ARCMSR_MSGCODE_RWBUFFER					0x0000fa00    /* iop msgcode_rwbuffer for message command */
-#define ARCMSR_IOCTL_WBUFFER					0x0000fe00    /* user space data to iop 128bytes */
-#define ARCMSR_IOCTL_RBUFFER					0x0000ff00    /* iop data to user space 128bytes */
-#define ARCMSR_HBB_BASE0_OFFSET					0x00000010
-#define ARCMSR_HBB_BASE1_OFFSET					0x00000018
-#define ARCMSR_HBB_BASE0_LEN					0x00021000
-#define ARCMSR_HBB_BASE1_LEN					0x00010000
-/*
+#define ARCMSR_MSGCODE_RWBUFFER			0x0000fa00    /* iop msgcode_rwbuffer for message command */
+#define ARCMSR_IOCTL_WBUFFER			0x0000fe00    /* user space data to iop 128bytes */
+#define ARCMSR_IOCTL_RBUFFER			0x0000ff00    /* iop data to user space 128bytes */
+#define ARCMSR_HBB_BASE0_OFFSET			0x00000010
+#define ARCMSR_HBB_BASE1_OFFSET			0x00000018
+#define ARCMSR_HBB_BASE0_LEN			0x00021000
+#define ARCMSR_HBB_BASE1_LEN			0x00010000
+/* 
 ************************************************************************
 **                SPEC. for Areca HBC adapter
 ************************************************************************
@@ -294,7 +344,7 @@ struct CMD_MESSAGE_FIELD {
 /* Host Interrupt Status */
 #define ARCMSR_HBCMU_UTILITY_A_ISR                      0x00000001
         /*
-        ** Set when the Utility_A Interrupt bit is set in the Outbound Doorbell Register.
+        ** Set when the Utility_A Interrupt bit is set in the Outbound Doorbell Register. 
         ** It clears by writing a 1 to the Utility_A bit in the Outbound Doorbell Clear Register or through automatic clearing (if enabled).
         */
 #define ARCMSR_HBCMU_OUTBOUND_DOORBELL_ISR              0x00000004
